import { get } from "svelte/store";
import { backendLib } from "../stores";
import { Backend } from "./backend";
import { DiffTree } from "./dt";
import { DiffTreeSpec } from "./dtspec";
import * as R from "ramda";
export class ClientDiffTreeBackend extends Backend {
    spec = {};
    dt = null;
    backend = null;
    bindings = {};
    constructor(spec) {
        super();
        this.spec = spec;
        this.dt = new DiffTree(spec.difftree);
        this.backend = (R.is(String, spec.backend)) ? get(backendLib)[spec.backend] : spec.backend;
        if (this.backend)
            this.backend.on("data", (table) => {
                this.emit("data", table);
            });
    }
    // @deprecated
    merge(bindings, newBindings) {
        return R.merge(bindings, newBindings);
    }
    async execute(q, name) {
        // interactions always coerce interaction state into
        // Array<object>.  difftree only wants the first binding
        if (R.is(Array, q))
            q = q[0] ?? {};
        const sql = this.dt.update(q).toSQL();
        console.log("ClientDT.execute", sql, q);
        // if there is no backend, then we still emit debugging info
        this.emit("debug", sql);
        if (this.backend)
            return this.backend.execute(sql, name);
    }
}
