import * as R from "ramda";
import { get } from "svelte/store";
import { Backend } from "./backend";
import { backendLib, iactLib } from "./stores";
export class QueryBackend extends Backend {
    backend;
    query;
    name;
    params;
    constructor(spec) {
        super();
        this.backend = spec.backend;
        this.query = spec.query;
        this.name = spec.name;
        this.params = spec.params;
        this.backend.on("data", (table, qName) => {
            if (qName == this.name) {
                this.emit("data", table, this.name);
            }
        });
    }
    prepareQuery(q, args) {
        let s;
        let currQuery = q;
        console.log('currQuery is,', currQuery);
        for (const param in args) {
            s = 'var(' + param + ')';
            //console.log('s is',s)
            //src: https://dmitripavlutin.com/replace-all-string-occurrences-javascript/
            currQuery = currQuery.replaceAll(s, args[param]);
            //console.log('q as of now is', q, args[param]);
        }
        return currQuery;
    }
    async execute(args) {
        for (const paramObj in args) {
            console.log('check', args[paramObj]);
            let tmpArgs = args[paramObj];
            this.params = R.mergeRight(this.params, tmpArgs);
        }
        console.log('QueryBackend arguments are', this.params);
        let currQuery = this.prepareQuery(this.query, this.params);
        console.log('QueryBackend.execute', currQuery);
        this.emit("debug", currQuery);
        console.log('QueryBackend calling to its own backend');
        return this.backend.execute(currQuery, this.name);
    }
}
