import * as R from "ramda";
import { Backend } from "./backend";
export class RandomBackend extends Backend {
    // @param attrs: list of attribute names to generate random numbers for
    //
    // always generates an "id" attribute ascending by row's index
    constructor(spec) {
        super();
        let attrs = spec.attrs ?? [];
        this.gen = (i) => {
            let pairs = attrs.map((attr) => [attr, Math.ceil(Math.random() * 100)]);
            pairs.push(["id", i]);
            return R.fromPairs(pairs);
        };
    }
    async execute(q, ...args) {
        this.emit("data", R.times(this.gen, 10), ...args);
    }
}
