# Layout


The layout is constructed before views, backends, and interactions.  The layout is currently trivial and consists of three Svelte components.  The layout components trivially wrap bootstrap's grid system.

* **VLayout**: vertically organizes children 
* **HLayout**: horizontally organizes children
* **Ref** : creates a placeholder DOM element that will contain a [View](../view) once it is created.


**Open Challenge**

* Rather than rigidly mirror the spec's hierarchical structure in the DOM, use it as grouping hints.  Instead, use a flat grid layout where views and widgets are absolutely positioned, and use some constraint solver to choose good looking positioning, spacing, and sizing.


## JSON Spec

See the [Typescript interface definition](./interface.ts) for spec information.


## Example 

```json
  "layout": {
    "id": "w1120",
    "width": 600,
    "height": 820,
    "type": "VLayout",
    "children": [
      {
        "id": "w1000",
        "width": 600,
        "height": 300,
        "type": "ref",
        "ref": "w1000"
      },
      {
        "id": "w1118",
        "width": 50,
        "height": 50,
        "type": "ref",
        "ref": "w1118",
        "name": "radio"
      },
      {
        "id": "w1119",
        "width": 50,
        "height": 50,
        "type": "ref",
        "ref": "w1119",
        "name": "dropdown"
      }

    ]
  }
```